LIBRARY IEEE;
USE IEEE.std_logic_1164.ALL;


ENTITY FSM IS 

	PORT(
		clk        :IN  std_logic;
		go         :IN  std_logic;
		rsltCMP    :IN  std_logic;
		BIsZero    :IN  std_logic;
		ready      :OUT std_logic;
		sel        :OUT std_logic;
		loadInputA :OUT std_logic;
		loadInputB :OUT std_logic;
		parLoadR   :OUT std_logic;
		parLoadQ   :OUT std_logic;
		upCount    :OUT std_logic;
		rstCount   :OUT std_logic

		);
END ENTITY FSM;


ARCHITECTURE RTL OF FSM IS
	TYPE state IS(St0, St1, St2, St3, St4);
	SIGNAL current : state := St0;
BEGIN
	PROCESS(clk)
	BEGIN
		IF(clk = '1' AND clk'EVENT) THEN
			CASE current IS 
			WHEN St0 =>
				IF( go = '1')THEN 
				    ready <= '0';    
				    sel <= '0';      
				    loadInputA <= '1';
				    loadInputB <= '1';
					rstCount <= '0';
					current	<= St1;				
				ELSE 
					ready <= '0';
					rstCount <= '1';
					current <= St0;
				END IF;				
			WHEN St1 =>
				IF( go = '1')THEN 
				    ready <= '0';    
				    sel <= '0';      
				    loadInputA <= '1';
				    loadInputB <= '1';
					rstCount <= '0'; 
					current	<= St1;				
				ELSE 
					IF(BIsZero = '1')THEN
						ready <= '1';
						sel <= '1';      
						loadInputA <= '0';
						loadInputB <= '0';
						rstCount <= '0';					
						current <= St0;
					ELSE
						ready <= '0';
						sel <= '0';      
						loadInputA <= '0';
						loadInputB <= '0';
						rstCount <= '0';					
						current <= St2;
					ENd IF;
				END IF;			
			WHEN St2 =>
				IF( go = '1')THEN 
				    ready <= '0';    
				    sel <= '0';      
				    loadInputA <= '1';
				    loadInputB <= '1';
					current	<= St1;				
				ELSE 
					IF( rsltCMP = '1' )THEN
						ready <= '0';
						sel <= '1';
						loadInputA <= '1';
						upCount <= '0';
						current <= St3;
					ELSIF( rsltCMP = '0' )THEN
						ready <= '1';
						sel <= '0';
						parLoadR <= '1'; 
						parLoadQ <= '1';  						
						current <= St4;						
					END IF;
				END IF;
			WHEN St3 =>
				IF( go = '1')THEN 
				    ready <= '0';    
				    sel <= '0';      
				    loadInputA <= '1';
				    loadInputB <= '1';
					rstCount <= '0';
					current	<= St1;				
				ELSE 
					IF( rsltCMP = '1' )THEN
						ready <= '0';
						sel <= '1';
						loadInputA <= '1';
						upCount <= '1';
						current <= St3;
					ELSIF( rsltCMP = '0' )THEN
						ready <= '1';
						sel <= '0';
						loadInputA <= '0';
						upCount <= '0';
						parLoadR <= '1'; 
						parLoadQ <= '1';  						
						current <= St4;						
					END IF;
				END IF;			
			WHEN St4 =>
				IF( go = '1')THEN 
				    ready <= '0';    
				    sel <= '0';      
				    loadInputA <= '1';
				    loadInputB <= '1';
				    parLoadR <= '0'; 
				    parLoadQ <= '0';   
					rstCount <= '1';
					current	<= St1;				
				ELSE 
					ready <= '0';
					sel <= '0';
				    parLoadR <= '1'; 
				    parLoadQ <= '1';  					
					upCount <= '0';
					current <= St4;
				END IF;			
			WHEN OTHERS => 
				    ready <= '0';    
				    sel <= '0';      
				    loadInputA <= '0';
				    loadInputB <= '0';
				    parLoadR <= '0'; 
				    parLoadQ <= '0';   
					upCount <= '0';
					rstCount <= '1';
					current	<= St0;				
			END CASE;
		END IF;
	END PROCESS;
END RTL;