LIBRARY IEEE;
USE IEEE.std_logic_1164.ALL;
USE IEEE.std_logic_unsigned.ALL;

ENTITY CounterN IS 
	GENERIC(
		N  : integer := 32
	);
	PORT(
		clk        :IN  std_logic;
		rst        :IN  std_logic;
		upCount    :IN  std_logic;
		parOut     :OUT std_logic_vector(N-1 DOWNTO 0)
	);
END ENTITY CounterN;


ARCHITECTURE RTL OF CounterN IS
BEGIN
	PROCESS(clk)
	VARIABLE temp : std_logic_vector(parOut'RANGE) := (OTHERS => '0');
	BEGIN
		IF(clk = '1' AND clk'EVENT) THEN
			IF(rst = '1')THEN 
				temp := (OTHERS => '0');
			ELSIF(upCount = '1')THEN
				temp := temp + 1;
			END IF;
			parOut <= temp;
		END IF;
	END PROCESS;
END RTL;