LIBRARY IEEE;
USE IEEE.std_logic_1164.ALL;


ENTITY TriStateN IS 
	GENERIC(
		N  : integer := 32
	);
	PORT(
		parLoad    :IN  std_logic;
		parIn      :IN  std_logic_vector(N-1 DOWNTO 0);
		parOut     :OUT std_logic_vector(N-1 DOWNTO 0);
		isNotZero  :OUT std_logic
	);
END ENTITY TriStateN;


ARCHITECTURE RTL OF TriStateN IS
	SIGNAL temp1 : std_logic;
BEGIN
	PROCESS(parIn)
	VARIABLE temp2 : std_logic := '0';
	BEGIN
		temp2 := '0';
		FOR i IN parIn'RANGE LOOP
			temp2 := temp2 OR parIn(i);
		END LOOP;
		temp1 <= temp2;
	END PROCESS;
	parOut <= parIn WHEN parLoad = '1' ELSE
			  (OTHERS => 'Z');
	isNotZero <= temp1 WHEN parLoad = '1' OR (parIn'EVENT AND parLoad = '1') ELSE
				 '0';
END RTL;